//
// Generated file, do not edit! Created by nedtool 5.5 from inet/opaltest/CAMPacket.msg.
//

#ifndef __INET__OPALTEST_CAMPACKET_M_H
#define __INET__OPALTEST_CAMPACKET_M_H

#if defined(__clang__)
#  pragma clang diagnostic ignored "-Wreserved-id-macro"
#endif
#include <omnetpp.h>

// nedtool version check
#define MSGC_VERSION 0x0505
#if (MSGC_VERSION!=OMNETPP_VERSION)
#    error Version mismatch! Probably this file was generated by an earlier version of nedtool: 'make clean' should help.
#endif

// dll export symbol
#ifndef INET_API
#  if defined(INET_EXPORT)
#    define INET_API  OPP_DLLEXPORT
#  elif defined(INET_IMPORT)
#    define INET_API  OPP_DLLIMPORT
#  else
#    define INET_API
#  endif
#endif


namespace inet {
namespace opaltest {

class CAMPacket;
} // namespace opaltest
} // namespace inet

#include "inet/common/packet/chunk/Chunk_m.h" // import inet.common.packet.chunk.Chunk


namespace inet {
namespace opaltest {

/**
 * Class generated from <tt>inet/opaltest/CAMPacket.msg:22</tt> by nedtool.
 * <pre>
 * class CAMPacket extends FieldsChunk
 * {
 *     int source;
 *     simtime_t creationTime;
 * 
 * 
 * 
 * 
 * }
 * </pre>
 */
class INET_API CAMPacket : public ::inet::FieldsChunk
{
  protected:
    int source = 0;
    omnetpp::simtime_t creationTime = SIMTIME_ZERO;

  private:
    void copy(const CAMPacket& other);

  protected:
    // protected and unimplemented operator==(), to prevent accidental usage
    bool operator==(const CAMPacket&);

  public:
    CAMPacket();
    CAMPacket(const CAMPacket& other);
    virtual ~CAMPacket();
    CAMPacket& operator=(const CAMPacket& other);
    virtual CAMPacket *dup() const override {return new CAMPacket(*this);}
    virtual void parsimPack(omnetpp::cCommBuffer *b) const override;
    virtual void parsimUnpack(omnetpp::cCommBuffer *b) override;

    // field getter/setter methods
    virtual int getSource() const;
    virtual void setSource(int source);
    virtual omnetpp::simtime_t getCreationTime() const;
    virtual void setCreationTime(omnetpp::simtime_t creationTime);
};

inline void doParsimPacking(omnetpp::cCommBuffer *b, const CAMPacket& obj) {obj.parsimPack(b);}
inline void doParsimUnpacking(omnetpp::cCommBuffer *b, CAMPacket& obj) {obj.parsimUnpack(b);}

} // namespace opaltest
} // namespace inet

#endif // ifndef __INET__OPALTEST_CAMPACKET_M_H

